-- CREATE DATABASE kuzuha;
-- 
-- GRANT SELECT,INSERT,UPDATE,DELETE,CREATE,DROP
-- 	ON kuzuha.*
-- 	TO kuzuha@localhost
-- 	IDENTIFIED BY 'kuzuha123';


--ݒO[vꗗ
DROP TABLE IF EXISTS constants_group;
CREATE TABLE constants_group (
	groupid tinyint UNSIGNED NOT NULL,
	groupname varchar(255),
	PRIMARY KEY (groupid)
) TYPE = myisam;

--ݒ
DROP TABLE IF EXISTS constants;
CREATE TABLE constants (
	name varchar(32) DEFAULT '' NOT NULL,
	value varchar(255),
	comment varchar(255),
	groupid tinyint UNSIGNED,
	FOREIGN KEY (groupid) REFERENCES constants_group(groupid),
	PRIMARY KEY (name)
) TYPE = myisam;

--}`[hpWꗗ
DROP TABLE IF EXISTS genre_list;
CREATE TABLE genre_list (
	genreid mediumint UNSIGNED NOT NULL auto_increment,
	genrename varchar(255),
	PRIMARY KEY (genreid)
) TYPE = myisam;

--}`[hpBBSꗗ
DROP TABLE IF EXISTS bbslist;
CREATE TABLE bbslist (
	bbsid mediumint UNSIGNED NOT NULL auto_increment,
	bbsname varchar(255),
	genreid mediumint UNSIGNED DEFAULT 0 NOT NULL,
	FOREIGN KEY (genreid) REFERENCES bbslist(genreid),
	PRIMARY KEY (bbsid)
) TYPE = myisam;


--Of[^
DROP TABLE IF EXISTS msglog;
CREATE TABLE msglog (
	msgid int UNSIGNED NOT NULL,
	bbsid mediumint UNSIGNED,
	threadid int UNSIGNED,
	refid int UNSIGNED,
	msgtime datetime DEFAULT '1000-01-01 00:00:00' NOT NULL,
	pcode varchar(12) DEFAULT '' NOT NULL,
	hostname varchar(255) DEFAULT '' NOT NULL,
	useragent varchar(255) DEFAULT '' NOT NULL,
	name varchar(255) DEFAULT '' NOT NULL,
	userattr varchar(255) DEFAULT '' NOT NULL,
	title varchar(255) DEFAULT '' NOT NULL,
	msg text,
	msgattr varchar(255) DEFAULT '' NOT NULL,
	FOREIGN KEY (bbsid) REFERENCES bbslist(bbsid),
	PRIMARY KEY (msgid)
) TYPE = myisam;

--ߋO
DROP TABLE IF EXISTS msglog_past;
CREATE TABLE msglog_past (
	msgid int UNSIGNED NOT NULL,
	bbsid mediumint UNSIGNED,
	threadid int UNSIGNED,
	refid int UNSIGNED,
	msgtime datetime DEFAULT '1000-01-01 00:00:00' NOT NULL,
	pcode varchar(12) DEFAULT '' NOT NULL,
	hostname varchar(255) DEFAULT '' NOT NULL,
	useragent varchar(255) DEFAULT '' NOT NULL,
	name varchar(255) DEFAULT '' NOT NULL,
	userattr varchar(255) DEFAULT '' NOT NULL,
	title varchar(255) DEFAULT '' NOT NULL,
	msg text,
	msgattr varchar(255) DEFAULT '' NOT NULL,
	logdate int UNSIGNED DEFAULT 0 NOT NULL,
	FOREIGN KEY (bbsid) REFERENCES bbslist(bbsid),
	PRIMARY KEY (msgid)
) TYPE = myisam;

--ߋOTCY
DROP TABLE IF EXISTS msglog_past_info;
CREATE TABLE msglog_past_info (
	logdate int UNSIGNED DEFAULT 0 NOT NULL,
	filesize int UNSIGNED DEFAULT 0 NOT NULL,
	modtime datetime DEFAULT '1000-01-01 00:00:00' NOT NULL,
	FOREIGN KEY (logdate) REFERENCES msglog_past(logdate)
) TYPE = myisam;


--JE^[
DROP TABLE IF EXISTS counter;
CREATE TABLE counter (
	counter int UNSIGNED DEFAULT 0 NOT NULL,
	bbsid mediumint UNSIGNED DEFAULT 0 NOT NULL,
	FOREIGN KEY (bbsid) REFERENCES bbslist(bbsid)
) TYPE = myisam;

--Q҃JEg
DROP TABLE IF EXISTS mbrcount;
CREATE TABLE mbrcount (
	mbrcode varchar(32) DEFAULT '' NOT NULL,
	mbrtime datetime DEFAULT '1000-01-01 00:00:00' NOT NULL,
	bbsid mediumint UNSIGNED DEFAULT 0 NOT NULL,
	FOREIGN KEY (bbsid) REFERENCES bbslist(bbsid)
) TYPE = myisam;

--Œnh
DROP TABLE IF EXISTS handlename;
CREATE TABLE handlename (
	name varchar(255) DEFAULT '' NOT NULL,
	pass varchar(255) DEFAULT '' NOT NULL,
	authlevel tinyint UNSIGNED DEFAULT 0 NOT NULL,
	PRIMARY KEY (name)
) TYPE = myisam;

--zXg
DROP TABLE IF EXISTS banlist;
CREATE TABLE banlist (
	id int UNSIGNED DEFAULT 0 NOT NULL,
	hostname varchar(255) DEFAULT '' NOT NULL,
	nametype bool DEFAULT 0 NOT NULL,
	bantype tinyint UNSIGNED DEFAULT 0 NOT NULL,
	PRIMARY KEY (id)
) TYPE = myisam;

--e֎~
DROP TABLE IF EXISTS ngword;
CREATE TABLE ngword (
	ngword text DEFAULT '' NOT NULL
) TYPE = myisam;


